<?php
/*
======================+= PHP MAIL TESTER =======================
=== A tool from the LuxSoft Freeware Factory: www.LuxSoft.eu ===

Upload this file to your calendar root folder and start it with your browser.
*/


function sendPhpMail($from,$recipients,$subject,$message) {

	$toArray = explode(';', $recipients);
	$msg = '';
	$hits = [];
	$toString = '';
	foreach($toArray as $k => $to) {
		if (preg_match("~^(?:^|\s|:)([^@\s]{1,40})@((?:[^@\s\.]{2,50}\.)+\w{2,6})(?:\.\s|\s|<|$)$~i",trim($to),$hits)) { //validate recipient mail addresses
			$toString .= $hits[0].', ';
		} else {
			$msg .= "Error in 'recipients' field $to<br>";
		}
	}
	if (!$msg) {
		$toString = rtrim($toString,' ,');
		$headers = "MIME-Version: 1.0\r\nContent-type: text/html; charset=utf-8\r\nFrom: {$from}\r\nReturn-path: {$from}\r\nDate: ".date(DATE_RFC2822);
		$message = wordwrap($message,70,"\r\n"); //lines should not be longer than 70
		$htmlMsg = "
<html>
<head>
  <title>PHP Mail Test message</title>
</head>
<body>
  <p style='color: #A00000'>{$message}</p>
</body>
</html>
";
		if(mail($toString,$subject,$htmlMsg,$headers)) {
			$msg = "Test mail from $from to $toString<br>- Subject: $subject<br>- Message: $message<br>Mail sent - OK";
		} else {
			$msg = "Test mail from $from to $toString<br>- Subject: $subject<br>- Message: $message<br>Error sending email!";
		}
	}
	return $msg;
}

//set error reporting
error_reporting(E_ALL); //errors, warnings and notices - test
ini_set('display_errors',1); ini_set('log_errors',1); //test

//init
$to = !empty($_POST['to']) ? htmlspecialchars($_POST['to']) : '';
$from = !empty($_POST['from']) ? htmlspecialchars($_POST['from']) : '';
$subject = !empty($_POST['subject']) ? htmlspecialchars($_POST['subject']) : '';
$message = !empty($_POST['message']) ? htmlspecialchars($_POST['message']) : '';
?>

<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<title>SMTP mail test page</title>
<style type="text/css">
header, footer, aside {display:block;}

* { padding:0; margin:0; }
body {font:12px arial, sans-serif; background:#F0F0F0; color:#304060; cursor:default;}
a {text-decoration:none; cursor:pointer;}
header {padding:0 1%;}
h3 {margin:8px 0; font-size:1.6em;}
h4 {margin:6px 0; font-size:1.4em;}
form {border:1px solid #808080; background:#FFFFFF; padding:20px; margin:20px 0;}
input, textarea {font:11px arial, sans-serif; width:100%;}
textarea {height:80px;}
button {margin-top:10px; font-size:1.0em; cursor:pointer;}
table {width:100%; border-collapse:collapse;}
td {padding:5px 0px;}
ul {margin-left:20px;}
.bLine {position:absolute; left:0; bottom:50px; width:98%; text-align:center;}
.mark {color:#AA0000;}
.center {text-align:center;}
div.navBar, div.endBar {
	position:absolute; left:0; right:0;
	padding:0 1%;
	background:#90B0FF;
	text-align:right;
	border:1px solid none #808080;
	line-height:20px;
	vertical-align:middle;
}
div.navBar {
	top:34px;
}
div.content {
	position:absolute; left:0; top:70px; right:0; bottom:100px;
	display: flex;
	align-items: stretch;
	padding:10px;
	overflow:auto;
}
div.left {
	width:460px;
	min-width:300px;
	margin:24px;
	text-align:justify;
}
div.right {
	flex-grow:1;
	margin:40px;
	padding:24px;
	background:#BFF6CC;
}
div.endBar {
	bottom:10px;
	font-size:0.8em;
}
.luxsoft {font:italic bold 1.1em arial,sans-serif; color:#AA0000;}
</style>
</head>

<body>
<header>
<h4>LuxCal Event Calendar</h4>
</header>
<div class="navBar">Your PHP version: <?php echo PHP_VERSION; ?></div>
<div class="content">
<div class="left">
<h3>PHP Mail Tester</h3>
<p>This script sends a simple email using the PHP mail function.</p>
<p><b>Instructions:</b></p>
<ul>
<li>In the "To" and "From" fields mail addresses should be specified in the following format xxxx@yyyyy.zzz (e.g. j.dowd@xmail.com).</li>
<li>In the "To" field multiple mail addresses can be specified, which must be separated by a semicolon (;).</li>
</ul>
<br>
<form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
<table>
<tr><td>To:</td><td> <input type='text' name='to' value='<?php echo $to ?>' /></td></tr>
<tr><td>From:</td><td> <input type='text' name='from' value='<?php echo $from ?>' /></td></tr>
<tr><td>Subject:</td><td> <input type='text' name='subject' value='<?php echo $subject ?>' /></td></tr>
<tr><td>Message:</td><td> <textarea name='message'><?php echo $message ?></textarea></td></tr>
<tr><td></td><td> <button type='submit'>&nbsp;Send&nbsp;</button></td></tr>
</table>
</form>
<p>Complete the form and press "Send". Thereafter the result will be shown in the right half of this window. Successful reception of the email depends on the validity of the recipient mail address(es).</p>
</div>
<?php
if ($_SERVER["REQUEST_METHOD"] == "POST") { //send mail
	echo "<div class='right'>\n";
	echo "<h4>Result:</h4>\n";
	$msg = sendPhpMail(htmlspecialchars_decode($from),htmlspecialchars_decode($to),htmlspecialchars_decode($subject),htmlspecialchars_decode($message));
	echo $msg."\n";
	echo "</div>\n";
}
?>
</div>
<div class="bLine mark"><h4>AFTER USE REMOVE THE php-mail-test.php FILE FROM THE SERVER!</h4></div>
<div class="endBar">
	design 2021 - powered by <a href="http://www.luxsoft.eu"><span class='luxsoft'>LuxSoft</span></a>
</div>
<br>&nbsp;
</body>
</html>
