<?php
/*
====================== PHP SESSION TESTER ======================
=== A tool from the LuxSoft Freeware Factory: www.LuxSoft.eu ===

Upload this file to your calendar root folder and start it with your browser.
*/

if (isset($_GET['php'])) { phpinfo(); exit; } //admin - show PHP installation page
session_name('TSTSESSID');
session_start();
?>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<title>LuxSoft Tools - PHP Session Test</title>
<meta name="description" content="LuxCal web calendar - a LuxSoft product">
<meta name="author" content="Roel Buining">
<meta name="robots" content="nofollow">
<style type="text/css">
* { padding:0; margin:0; }
body {font:14px arial, sans-serif; background:#E0E0D0; color:#2B3856; cursor:default;}
.centerBox {text-align:center; display:table; background:#FFFFFF; margin:80px auto; padding:20px; border:2px solid red; border-radius:5px; box-shadow:5px 5px 5px #888;}
.hilite {margin:24px 0; padding:20px; background:#C0FFFF; color:#A04040; font:bold 16px arial, sans-serif;}
.hilite span {font-size:2em;}
</style>
</head>

<body>
<div class="centerBox">
<h2>== Test the PHP Session Mechanism ==</h2>
<br>
<h3>~ Another <a href="https://www.luxsoft.eu" target='_blank'>LuxSoft</a> Mini Tool ~</h3>
<br><br>
<h4>Reload (Ctrl F5 or <span style="font-size:1.4em;">&#x27F3;</span>) the page a couple of times.<br>If the counter does not increment each reload, the PHP sessions don't work.</h4>
<br>
<p>When the PHP sessions are not working, often the "session.save_path" is set <br>incorrectly in the php.ini file of the PHP installation.<br>Suggestion: If you can, try setting it to "/tmp" in the php.ini file or ask your provider.</p>
<br>
<p>Press <a href="<? $_SERVER['PHP_SELF']?>?php" target='_blank'>Show PHP Info</a> to see your PHP installation details and scroll down to 'session'.
<br><br><br>
<?php
if (!empty($_SESSION['counter'])) { //counter kept in a PHP session variable
	$_SESSION['counter']++; //increment counter
	echo "<span class='hilite'>The current reload count is: <span>{$_SESSION['counter']}</span></span>";
} else {
	echo "<span class='hilite'>No session counter found; counter set to <span>1</span></span>";
	$_SESSION['counter'] = 1;
}
echo "<br><br><br>
<p>Btw, you are running PHP version <b>".phpversion()."</b></p>
<br>
<p>Oh, uh, and the server date / time is <b>".date('l jS \of F Y h:i A')."</b></p>";

?>
</div>
</body>
</html>
